using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace Filter
{
    public partial class Form1 : Form
    {
        DataColumn[] Columns = new DataColumn[4];
        DataTable table = new DataTable();
        string TextFilterText = string.Empty;

        public Form1()
        {
            InitializeComponent();

            Osvjezi();
        }

        public void Osvjezi()
        {
            GridColumnDescriptor gdc;
            gridGroupingControl1.TableDescriptor.TopLevelGroupOptions.ShowFilterBar = true;
            for (int i = 0; i < 4; i++)
            {
                Columns[i] = new DataColumn();
                Columns[i].ColumnName = i.ToString();
                gdc = new GridColumnDescriptor(Columns[i].ColumnName);
                gdc.HeaderText = "Filter Test";
                gdc.AllowFilter = true;

                //you can change this to i<1 if you wish to experiment wth just one text box filter
                if (i <= 1)
                {
                    gdc.Appearance.FilterBarCell.CellType = "TextBox";
                }
                table.Columns.Add(Columns[i]);
                gridGroupingControl1.TableDescriptor.Columns.Add(gdc);

            }
            for (int i = 0; i < table.Columns.Count; i++)
            {
                DataRow row = table.NewRow();
                for (int j = 0; j < 4; j++)
                {
                    if (i % 2 == 0 && j % 2 == 0)
                        row[j] = j.ToString();
                    else row[j] = i.ToString();
                }
                table.Rows.Add(row);
            }
            gridGroupingControl1.DataSource = table;
        }


        //Here is the code you sent...
        private void gridGroupingControl1_TableControlCurrentCellChanged(object sender, GridTableControlEventArgs e)
        {
            GridCurrentCell cc = e.TableControl.CurrentCell;
            GridTextBoxCellRenderer cr = cc.Renderer as GridTextBoxCellRenderer;
            if (cr != null)
            {
                GridTableCellStyleInfo style = cr.CurrentStyle as GridTableCellStyleInfo;

                if (style.TableCellIdentity.DisplayElement.Kind == DisplayElementKind.FilterBar && style.CellType == "TextBox")
                {
                    int RowIndex = cc.RowIndex;
                    int ColIndex = cc.ColIndex;
                    object getEditState = cr.GetEditState();
                    TextFilterText = cr.ControlText;
                    GridTableDescriptor td = e.TableControl.TableDescriptor;
                    string name = td.VisibleColumns[td.ColIndexToField(cc.ColIndex)].Name;
                    td.RecordFilters.Remove(name);
                    FilterCondition condition = new FilterCondition(FilterCompareOperator.Like, cr.ControlText + "*");
                    RecordFilterDescriptor rfd = new RecordFilterDescriptor(name, condition);
                    td.RecordFilters.Add(rfd);
                    cc.MoveTo(RowIndex, ColIndex);
                    cc.BeginEdit();
                    cr.SetEditState(getEditState);
                }
            }

        }


        private void gridGroupingControl1_TableControlCellDrawn(object sender, GridTableControlDrawCellEventArgs e)
        {
            GridTableCellStyleInfo style = e.Inner.Style as GridTableCellStyleInfo;
            if (TextFilterText != string.Empty && style.TableCellIdentity.DisplayElement.Kind == DisplayElementKind.FilterBar && style.CellType == "TextBox")
            {
                e.Inner.Cancel = true;
                e.Inner.Graphics.DrawString(TextFilterText, e.Inner.Style.GdipFont, new SolidBrush(e.Inner.Style.TextColor), e.Inner.Bounds);
            }
        }
    }
}